;;  -------------------------------------------------------------------
;;  NOM:        MATRIX.ASM
;;  CREAT PER:  Sergio Blanco Cuaresma, Francesc Galiano Baixaul
;;  DATA:       25/03/2001
;;  DESCRIPCIO: Programa en ensamblador que calcula el producte d'una
;;              matriu per un vector, donant com a resultat un altre
;;              vector.
;;  -------------------------------------------------------------------

        ASSUME cs:Codi, ds:Dades, ss:Pila

Pila SEGMENT STACK 'stack'      ; Declaraci del Segment de pila
        DW 256 DUP (?)          ; (pot contenir fins a 256 words)
Pila ENDS



Dades SEGMENT           ; Declaraci del Segment de dades
        ; Lloc per posar la DEFINICIO DE LES VARIABLES:
        ;                   ##########################
	Matriu	DB	0,  0,  0,  0,  0,  0,  0,  0
		DB	255, 255, 255,  255,  255, 255,  255, 255
		DB	2, 10, 11,  0,  1, 20,  4,  5
		DB	1,  2,  3,  4,  5,  6,  7,  8
	
	Vector  DB	1, 1, 1,  1,  1, 1,  1,  1
	
        Result	DW 4 DUP (?)
        ;Les altres variables de l'algorisme:
        ; DX <- Temp
        ; CL <- f
        ; CH <- c
Dades ENDS

MATRIU_FILA_INI		EQU	2
MATRIU_COL_INI		EQU	1
MATRIU_NUM_COL		EQU	8

VECTOR_FILA_INI		EQU	1
VECTOR_COL_INI		EQU	1
VECTOR_NUM_COL		EQU	MATRIU_NUM_COL	; Han de tenir sempre el mateix nombre de col.


Codi SEGMENT            ; Declaraci del Segment de codi
        ; Lloc per posar el CODI DE LES SUBRUTINES:
        ;                   ######################


; Funci: DesplElemTau2D
; Calcula el desplaament d'un element d'una taula bidimensional, segons:
; ((f-Fini) * #COLS + (c-Cini)) * Mida(Elem)
; Parmetres (per registre):
;        DH: f           CH: c
;        DL: Fini        CL: Cini
;        BL: #COLS       BH: Mida(Elem)
; Resultat (per registre): DI.

DesplElemTau2D PROC
	push	dx
	push	ax
	push	cx
	sub	dh, dl
	mov	al, dh
	mul	bl		; Resultat (f-Fini) * #COLS en AX
	
	sub	ch, cl
	mov	cl, 0
	xchg	ch, cl		; Resultat (c-Cini) en CX
	
	add	ax, cx
	mul	bh		; Resultat final a AX
	
	mov	di, ax
	pop	cx
	pop	ax
	pop	dx
	ret
DesplElemTau2D ENDP



Principal PROC          ; Programa principal: s el que s'executar
        mov     ax, Dades       ; Inicialitzar DS per poder accedir a
        mov     ds, ax          ;       les variables del segment Dades
    
        ; Lloc per posar el CODI DEL PROGRAMA PRINCIPAL:
        ;                   ###########################

	mov	cl, 2		; CL - Comptador del bucle principal (files)
per1:	cmp	cl, 5
	ja	fper1
	mov	dx, 0		; DX - Variable Temporal (columnes)
	mov	ch, 1
per2:	cmp	ch, 8		; CH - Comptador del segon bucle
	ja	fper2
	push	dx		; Guardem el 2 registres que seran modificats
	push	cx		; amb parametres per cridar la funci
	
	;;; Posicio de la matriu
	mov	dh, cl			;Fila
	;mov	ch, ch			;Columna, no cal pq coincideix amb el bucle
	mov	dl, MATRIU_FILA_INI	;Fila inicial
	mov	cl, MATRIU_COL_INI	;Columna inicial
	mov	bl, MATRIU_NUM_COL	;Num de columnes
	mov	bh, TYPE Matriu		;Mida de l'element
	call	DesplElemTau2D		;Calculem posicio, que guardara a DI
	
	mov	al, Matriu[di]		;A AL tenim un dels nmeros a multiplicar

	;;; Posicio del vector
	mov	dh, 1			;Fila (sempre 1 pq es un vector)
	;mov	ch, ch			;Columna, no cal pq coincideix amb el bucle

   ;Si es donen algunes igualtats podrem reduir codi ja que els registres contenen ja
   ;el valor correcte
   IF MATRIU_FILA_INI NE VECTOR_FILA_INI
	mov	dl, VECTOR_FILA_INI	;Fila inicial
   ENDIF
   IF MATRIU_COL_INI NE VECTOR_COL_INI
	mov	cl, VECTOR_COL_INI	;Columna inicial
   ENDIF
   IF MATRIU_NUM_COL NE VECTOR_NUM_COL
	mov	bl, VECTOR_NUM_COL	;Num de columnes
   ENDIF
   IF TYPE Vector NE TYPE Vector
	mov	bh, TYPE Vector		;Mida de l'element
   ENDIF
   
	call	DesplElemTau2D		;Calculem posicio, que guardara a DI

	mul	byte ptr Vector[di]	;Multipliquem AL * 1 elem. Byte del Vector
	
	pop	cx
	pop	dx
	
	add	dx, ax		; Afegim al valor temporal
	
	inc	ch
	jmp	per2
fper2:
	mov	bl, cl
	xor	bh, bh
	shl	bx, 1			; Multipliquem per 2 pq es un Word
	mov	Result[bx-4], dx	; Restem 4 per ser un Word
					; Hem guardat el resultat
	inc	cl
	jmp	per1
fper1:	
	
	

        mov     ah, 4Ch         ; Indicar al SO que s'ha acabat el programa
        mov     al, 0           ;       Codi de sortida (Exit code)
        int     21h
Principal ENDP


Codi ENDS


        END     Principal

